/*
 * Copyright (c) 2021-2022 Akitsugu Komiyama
 * under the MIT License
 */

 /// <summary>
 /// t@C֘A
 /// </summary>
class TFile {
    // ̃GR[hŊĴ擾@\ƂȂB
    using PFNAnalyzeEncoding = int(WINAPI*)(const WCHAR* pwszFileName, DWORD_PTR lParam1, DWORD_PTR lParam2);
    static PFNAnalyzeEncoding Hidemaru_AnalyzeEncoding;

    // w̏Gۂencodew肵āAt@Ceǂݍ
    using PFNLoadFileUnicode = HGLOBAL(WINAPI*)(const WCHAR* pwszFileName, int nEncode, UINT* pcwchOut, DWORD_PTR lParam1, DWORD_PTR lParam2);
    static PFNLoadFileUnicode Hidemaru_LoadFileUnicode;
public:
    TFile();

    /// <summary>
    /// MsCodePage  HmEncode ꊇň߂̃NX
    /// </summary>
    class IEncoding {
        int hm_encode;
        int ms_codepage;
    public:
        IEncoding(int hm_encode, int ms_codepage);
        IEncoding() = default;
        IEncoding(const IEncoding&) = default;

        /// <summary>
        /// Gۂencodel𓾂Bɂ }Nencodel u&amp;  0x3FvANDrbgZlj
        /// <para>https://help.maruo.co.jp/hidemac/html/060_Keyword_State.html#encode 0`28Ɠ</para>
        /// </summary>
        int getHmEncode();

        /// <summary>
        /// }CN\tgCodePagel𓾂B
        /// <para>Win32apigĕGR[hɂ͂̒lKvƂȂ邾낤B</para>
        /// </summary>
        int getMsCodePage();
    };

    /// <summary>
    /// GۂEncodelMsCodePage̒l𓾂邽߂̃\bh
    /// GۂencodelƂ́Aɂ }Nencodel u&amp; 0x3FvANDrbgZlj
    /// <para>https://help.maruo.co.jp/hidemac/html/060_Keyword_State.html#encode 0`28Ɠ</para>
    /// </summary>
    /// <param name = "hm_encode">GۂEncodel</param>
    /// <returns>IEncoding^̃IuWFNgBMsCodePage  HmEncode 𓾂B</returns>
    IEncoding getEncoding(int hm_encode);

    /// <summary>
    /// w̃t@C̐΃pXIEncoding^IuWFN𓾂邽߂̃\bh
    /// <para>iȂ̏Gۂ̃t@C̃GR[hf̐ݒɏ]BėpIȃt@CGR[h֐ł͂Ȃj</para>
    /// </summary>
    /// <returns>IEncoding^̃IuWFNgBMsCodePage  HmEncode 𓾂B</returns>
    IEncoding getEncoding(std::wstring filepath);
    const std::map<int, int> getEncodingMap();

    class IHidemaruStreamReader {
        IEncoding encoding;
        std::wstring filepath;
    public:
        IHidemaruStreamReader(std::wstring filepath, IEncoding encoding);
        ~IHidemaruStreamReader();

        /// <summary>
        /// ΏۂƂȂĂt@CIEncoding𓾂BGۃx[Xencodinglƃ}CN\tgx[XCodePagel𓾂邱ƂoB
        /// </summary>
        IEncoding getEncoding();

        /// <summary>
        /// ΏۂƂȂĂt@C̃eLXgeꊇœǂݍށB
        /// </summary>
        std::wstring read();

        /// <summary>
        /// ΏۂƂȂĂt@C̐΃pX̎擾B
        /// </summary>
        std::wstring getFilePath();

        /// <summary>
        /// ݂Ђ炢ĂA IHidemaruStreamReader IuWFNgB
        /// </summary>
        void close();
    };

    /// <summary>
    /// GۂŃt@C̃GR[h𔻒fA̔fʂɊÂăt@C̃eLXge擾B
    /// iGۂɐݒ肳Ăeɏ]j
    /// </summary>
    /// <param name = "filepath">ǂݍݑΏۂ̃t@C̃pX</param>
    /// <param name = "hm_encode">GR[h(Gۃ}Ńuencodev̒l)ĂȂΎw肷Aw肵ȂꍇGAPI̎ɔCB</param>
    /// <returns>IHidemaruStreamReader^̃IuWFNgB</returns>
    IHidemaruStreamReader open(std::wstring filepath, int hm_encode = -1);
};

